/*	Script: InsertUnicode.js
		Application: Adobe Indesign CS, CS2; Adobe InCopy CS, CS2
		Platform: Crossplatform
		Authors: kaatm, Elsynor
		Target: insert a text character with a given unicode value
Using:
1. Place the text cursor into text frame, table cell or Story Editor window.
2. Run script.
3. Type hexadecimal unicode value.
4. Press [OK] or hit [Enter].
5. You can see a glyph with given unicode if its supported in your font.
	or, like in Microsoft Word
1. Type chosen unicode value directly within text frame.
2. Highlight theese characters.
3. Run script.

Its recommended to assign keyboard shortcut to this script
*/
var MyDoc = app.activeDocument;
var MySel = app.activeDocument.selection;
var aCode = '';
Present = true;

if (MySel.length>0){
	if (MySel[0].constructor.name == 'Text'){
		MyUnicode = GetACode(MySel[0].contents);
		if (!isNaN(MyUnicode)){
			MySel[0].contents = String.fromCharCode(MyUnicode);
			MySel = app.activeDocument.selection;
			MyDoc.select(MySel[0].insertionPoints[1]);
		}
	}
	if (MySel[0].constructor.name == 'InsertionPoint'){
		MySel[0].contents = String.fromCharCode(GetACode(''));
	}
}

function GetACode(aCode){
	if (aCode != '') {
		if (aCode.length > 4 || (aCode.search(/[^0123456789ABCDEF]/i) != -1)) return NaN;
  }
  else {
	do {
		if ((aCode = prompt('Type a unicode HEX value', aCode)) == null) return NaN;
		} while (aCode.length > 4 || (aCode.search(/[^0123456789ABCDEF]/i) != -1));
	}
	return parseInt(aCode, 16);
}